<?php
 /*  by AlberT, Emiliano Gabrielli  v.  2.2           29.07.2000
 
 ****************
 *   SINOTTICA: *
 ****************
 
 <?php require ("AlberT-counter.inc.php") ?>     <-- da includere all'inizio di ciascuna pagina in cui deve comparire il contatore

 ****** ATTENZIONE!!! - QUESTO SCRIPT SETTA DEI COOKIES, QUINDI VA INCLUSO
 (IL "REQUIRE" DI CUI SOPRA) PRIMA DI QUALSIASI ALTRO TAG HTML (<HTML>,...) 

 <?php echo contatore( string [pagina],int [is_graphic],int [digits] ) ; ?>  <-- in ogni punto in cui si vuole un contatore
 
 GLI ARGOMENTI SONO TUTTI OPZIONALI E, SE FORNITI RIMPIAZZANO QUELLI DI DEFAULT. IL DEFAULT E' IMPOSTATO NELLO SCRIPT TRAMITE
 L' ARRAY ASSOCIATIVO $conf[].
  
 E' consigliato passare la variabile $PHP_SELF come primo argomento cosi' da avere un riferimento esplicito alla pagina chiamante;
 se non si desidera visualizzare il contatore, ma si desidera che questo faccia il suo lavoro omettere il costrutto "echo". 

 Da questa versione e' possibile decidere il timeout entro il quale il
 contatore "non funzionera'", di default 2 minuti.
 Questo viene ottenuto tramite due cookies. Se l'utente rifiuta i cookies
 il contatore semplicemente NON conta ! (meglio qualche hit in meno che
 migliaia fasulli !!!).

 *********
 * TODO: *
 *********
 Implementare una lista di "Ignore Host" (ad esempio il locale, o la
 propria sottorete) cosi' da non contare i propri stessi accessi o bannare
 hosts sgraditi!
 
 Migliorare in modo consistente il logging dei REFERERS: da dove vieni,
 che OS usi, che Browser, da quanto tempo non ti vedevo ...  ;-)
 
 ******************
 * LICENZA D'USO: *
 ******************
 
 OGNI USO E DIFFUSIONE DI QUESTO SCRIPT E' CONSENTITO ED INCORAGGIATO DALL' AUTORE, ANCHE PER USI COMMERCIALI, PURCHE' NEL RISPETTO
 DI QUESTA LICENZA E A CONDIZIONE CHE, ANCHE NELLE VERSIONE MODIFICATE, VENGA LASCIATA INTATTA QUESTA LICENZA E I RIFERIMANTI 
 ALL'AUTORE ORIGINALE.  	                                                                                       
 Questo script puo' essere usato  sotto licenza Gnu GPL 2.0 o successive.
 
 L'AUTORE DECLINA OGNI GENERE DI RESPONSABILITA' DERIVANTE DALL' USO DI QUESTO SCRIPT, CHE VIENE FORNITO "COSI' COM'E'" SENZA ALCUN
 TIPO DI GARANZIA, NEANCHE IMPLICITA. CHI UTILIZZI QUESTO SCRIPT ACCETTA IMPLICITAMENTE QUESTA GARANZIA E LO FA SOTTO LA SUA DIRETTA 
 RESPONSABILITA'.
 
 ***********
 * AUTORE: *
 ***********
 
 Chi volesse contattare l'autore per suggerimanti, consigli, bugs e quant' altro puo' farlo all' indirizzo di posta elettronica:
							AlberT@SuperAlberT.it
 */

 /////////////////////////////////////////////////////////
 //		VARIABILI DA IMPOSTARE		       	//

//////////////////////////////////////////////////////////////////////////////////////////////////
 $conf["datfile"]	= $config["siteroot"]."/scripts/AlberT-counter/counter.dat"; 	        // NOME DEL FILE IN CUI SALVARE I DATI (PATH ASSOLUTO SUL SERVER).
 $conf["bannfile"]	= $config["siteroot"]."/scripts/AlberT-counter/bann.list.php";          // NOME DEL FILE IN CUI INSERIRE GLI HOST DA BANNARE - NUMERO IP  (PATH ASSOLUTO SUL SERVER).
 $conf["lockfile"]	= "/tmp/count.lock";                    				// NOME DEL FILE DI LOCK (LA DIR DEVE AVERE IL PERMESSO DI SCRITTURA!).
 $conf["defaultpage"]	= "http://www.superAlberT.it";						// SE NON VIENE PASSATO ALCUN ARGOMENTO IL CONTATORE INCREMENTA QUESTO! 
 $conf["imgdir"]	= "/scripts/AlberT-counter/digits";                                     // DIRECTORY CONTENENTE LE IMMAGINI (I NUMERI DA 0 A 9).
 $conf["cifre"]		= 6 ;									// NUMERO DI CIFRE DEL CONTATORE ( 0001234 ); SE POSTO A 0 IL 
 												// CONTATORE NON AGGIUNGE ZERI PRIMA DEL NUMERO.		
 $expire                = time()+180;                                                           // TEMPO MINIMO DI AGGIORNAMENTO DEL CONTATORE
 $conf["pagina"]        = $PHP_SELF;                                                            // RIFERIMENTO PER IL COOKIE: OGNI PAGINA HA UNA SUA PROPRIA SCADENZA
 /////////////////////////////////////////////////////////////////////////////////////////////////
 
 /////////////////////////////////////////////////////////
 /////////////////////////////////////////////////////////
 ////	NON E' NECESSARIO MODIFICARE NIENT'ALTRO !!!  ////
 /////////////////////////////////////////////////////////
 /////////////////////////////////////////////////////////
if ( isset($AlberTcounter) ) { $setted=1; };
$conf["r_ip"]=$REMOTE_ADDR;

setcookie( "AlberTcounter[pagina]", $conf["pagina"], "", "/" );
setcookie( "AlberTcounter[scadenza]", "$expire", "", "/" ); 
 
function contatore($pagina = "", $is_graphic = 1, $digits = 0){                                 // $IS_GRAFPHIC DETERMINA SE IL CONTATORE
 								 				// E' TESTUALE O GRAFICO. SE NON VIENE PASSATO QUESTO
      												// ARGOMENTO IL CONTATORE E' GRAFICO.
        $ver="2.2";
	global $conf;                                                                           
	global $AlberTcounter;	
	/////////////////////////////////////////////////////////// 
	//      LEGGE DA BANNFILE GLI IP DA NON CONSIDERARE      //
	///////////////////////////////////////////////////////////
	if ( file_exists( $conf["bannfile"]) || ($conf["bannfile"]!="") ) {  
  	  $bannlist = file($conf["bannfile"]);
  	  for ($k=0; $k<count($bannlist); $k++) {
    	    if ( $conf["r_ip"] == trim($bannlist[$k]) ) {
              $banned="BANNED";
	      break;
            }
          }
	}
	if(!$pagina) {
 		$pagina = $conf["defaultpage"];
 	}
 	if(!$digits) {
 		$digits = $conf["cifre"];
 	}
 	$timeout=time()+5;                        		
	//////////////////////////////////////////	
 	//	CREA UN FILE DI LOCK		//
 	//////////////////////////////////////////
 	while (file_exists($conf["lockfile"]) && time() < $timeout) {
    		clearstatcache();
    		sleep(1);
 	}
 	clearstatcache();
 	if ( file_exists($conf["lockfile"]) ) {
    		exit;
 	}
 	$lock = fopen ($conf["lockfile"],"w");

 	////////////////////////////////////////////////////////////////////
 	// APRE IN LETTURA E SCRITTURA IL FILE DAT, SE NON ESISTE LO CREA //
 	////////////////////////////////////////////////////////////////////
 	if ( !file_exists( $conf["datfile"]) ) {  
 	        $fp = fopen( $conf["datfile"],"w+");
 	}
 	else {
 		$fp = fopen( $conf["datfile"],"r");
 	} 
 	rewind($fp);
 	//////////////////////////////////////////////////////////
 	// LEGGE DAL DATFILE, INCREMENTA DI UNO, E CI SCRIVE	//
 	//////////////////////////////////////////////////////////
 	$ok=0;
 	$contenuto = fread($fp,filesize($conf["datfile"])) ; 		                        // LEGGE L'INTERO FILE 
 	if ( $inizionome = strpos($contenuto,$pagina) ) { $ok=1; }	                        // TROVA LA POSIZIONE DELLA PAGINA DA CONTARE 
 	$sub = substr($contenuto,$inizionome);         				
 	$pos1 = strpos($sub,">> ");                                        
 	$pos2 = strpos($sub," <<"); 
 	$pos1 += 3;                                                   	                        // E DEL NUMERO DI VISITE
 	$lunghezza = $pos2-$pos1;                                           
 	if ( $ok==1 ) {
 		$count = substr($sub,$pos1,$lunghezza);
                                                                                                //CONTROLLA CHE NON SIA GIA' CONTATO
		if ( ($banned != "BANNED") and ($setted != 1) || ($AlberTcounter["pagina"] == $conf["pagina"]) and ($AlberTcounter["scadenza"] <= time()) ) {	
 	        	$count ++;	                                                        // INCREMENTA DI UNO IL CONTATORE
		}   
 		$newcontenuto = substr($contenuto,0,$inizionome+$pos1).$count.substr($contenuto,$pos2+$inizionome); 
 	}
 	else {
 		$count=1;
 		$newcontenuto = $contenuto.$pagina."\t>> ".$count." <<\n" ;
 	}
 	fclose($fp);
 	$fp = fopen($conf["datfile"],"w");
 	rewind($fp);
 	fwrite($fp,$newcontenuto);
 	//////////////////////////////////////////////////////////
 	//	  CHIUDE I FILES E CANCELLA IL LOCK FILE	//
 	//////////////////////////////////////////////////////////
 	fclose($fp);
 	fclose($lock);
 	unlink ( $conf["lockfile"] );
 		if ( $digits > 0 ) {
 	       	$complemento = $digits-strlen("$count");
 		}
 		else {
 			$complemento = strlen("$count");
 		}
 		for ($i=0; $i < $complemento; $i++) {
 			$mask .= "0";
 		}
 		$mask .= "$count" ;
 		echo "<!-- AlberT-counter_$ver -->";
 		if ( $is_graphic == 1 ){
			echo "<a href='http://www.SuperAlberT.it' border='0'>";
 			for ($i=0; $i < $digits; $i++) {
 				$cifra[$i] = substr( $count, $i, 1);
 				echo "<img src='".$conf["imgdir"]."/digit_".$mask[$i].".gif' border='0' alt='".$mask[$i]."'>";
 			}
			echo "</a>";
 		}
 		else {
 			if ($digits > 0) {
 				return $mask;
 			}
 			else {
 				return $count;
 			}
 		}
 		echo "<!-- by Emiliano 'AlberT' Gabrielli - AlberT@SuperAlberT.it -->";	
}
?>
